unit HVQBDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, IBDataset, ExtCtrls, IB_Components, StdCtrls, Grids, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox4: TListBox;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ImportHVQB, LoginFrm;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var mySql,
    db, pw, us  : pChar;
begin
 Application.CreateForm ( TFrmLogIn, FrmLogIn );
 if ( FrmLogIn.ShowModal = mrOk ) then
  begin
   db := PChar(FrmLogIn.Edit1.Text);
   us := PChar(FrmLogIn.Edit2.Text);
   pw := PChar(FrmLogIn.Edit3.Text);
   HVQB_SetDatabaseName ( db );
   HVQB_SetUserName     ( us );
   HVQB_SetPassword     ( pw );
   mySql := HVQB_ExecuteQBuilder;
   if mySql <> '' then Memo1.Text := mySql;
  end;
 FrmLogIn.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var s : string; p : pChar;
begin
 if HVQB_InitOrderBy then
 repeat
  p := HVQB_NextOrderByField;
  if not ( p = nil ) then
           s := StrPas ( p );
  if ( s <> '' ) then ListBox1.Items.Add ( s );
 until ( HVQB_OrderByFieldsEnd );
end;

procedure TForm1.Button3Click(Sender: TObject);
var s : string;
begin
 if HVQB_InitGroupBy then
 repeat
  s := StrPas ( HVQB_NextGroupByField );
  if ( s <> '' ) then ListBox2.Items.Add ( s );
 until ( HVQB_GroupByFieldsEnd );
end;

procedure TForm1.Button4Click(Sender: TObject);
var s, s2 : string;
begin
 if HVQB_InitJoinedRelations then
 repeat
  // Ask for the Joined Fields before asking for the join itself
   repeat
    s2 := StrPas ( HVQB_NextJoin );
    if ( s2 <> '' ) then ListBox4.Items.Add ( s2 );
   until ( HVQB_JoinsEnd );
  s := StrPas ( HVQB_NextJoinedRelation );
  if ( s <> '' ) then ListBox3.Items.Add ( s );
 until ( HVQB_JoinedRelationsEnd );
end;

end.
